#!/usr/bin/python
# coding: utf-8
#
# Brunie nicolas, War of Blood
#
 
 
try:
  import sys
  import pygame
  from pygame.locals import *
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)
  sys.exit(2)



class Camera:
  def __init__(self,screen,background,(longueur,largeur)):
    self.longueur = longueur
    self.largeur = largeur
    self.screen = screen
    self.background = background
    self.movable = []
    self.static = []
    self.dep = 0,0
    self.tmp_time = 0
    self.pos = 0,0
    self.listeMouvement = []

  def addDeplace(self,ob):
    self.listeMouvement.append(ob)

  def deplace(self,x,y):
    nx = self.dep[0] + x
    ny = self.dep[1] + y
    self.dep = nx,ny

  def update(self,time):
    self.tmp_time += time
    if self.tmp_time > 100:
      x,y = self.dep
      dx = x * (self.tmp_time / 20)
      dy = y * (self.tmp_time / 20)
      self.tmp_time = self.tmp_time % 100
      self.deplaceEffectif(dx,dy)

  def center(self,perso,time=0):
    px,py = perso.rect.center
    x,y = 0,0 # self.pos
    # centrage horizontal
    b = 0
    if px - x > self.longueur-100:
      self.deplaceEffectif(-(px-self.longueur+100),0)
    elif px - x  < 100:
      self.deplaceEffectif(100-px,0)
    else: b -= 1
    # centrage vertical
    if py > y + self.largeur - 100:
      self.deplaceEffectif(0,-(py - self.largeur + 100 ))
    elif py < y + 100:
      self.deplaceEffectif(0,(y+100-py))
    else: b -= 1

    if b == -2:
      dx =  - (px - self.longueur / 2)
      dy = - (py - self.largeur / 2) 
      self.deplaceEffectif(dx * time / 250.0, dy * time / 250.0)
    #print self.pos

  def deplaceEffectif(self,dx,dy):
    x,y = int(dx),int(dy)
    px,py = self.pos
    self.pos = px-x,py-y
    for ob in self.listeMouvement:
      ob.cameraDeplace(x,y)
    for sgroup in self.static:
      for ssprite in sgroup.sprites():
        self.screen.blit(self.background, ssprite.rect, ssprite.rect)
        ssprite.deplacement(x,y)
    for mgroup in self.movable:
      for msprite in mgroup.sprites():
        msprite.deplacement(x,y)

  def addMouvable(self,group):
    self.movable.append(group)

  def addStatic(self,group):
    self.static.append(group)
