#!/usr/bin/python
# coding: utf-8
#
# Brunie nicolas, War Of Blood
#
 
try:
  import sys
  import random
  import math
  import os
  import getopt
  import pygame
  from socket import *
  from Common import *
  from Perso import *
  from Particle import *
  from pygame.locals import *
  from Badguy import *
  from Weapons import *
  from Environnement import *
  from Level import *
  from Caisse import Caisse
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)
  sys.exit(2)



class InterfaceDesigner:
  def __init__(self,screen,level):
    self.iconeGroup = pygame.sprite.Group()
    self.id = 1
    self.screen = screen
    self.level = level
    self.description = {}
    blocklist = []
    i = 0
    while 1:
      try:
        open("./data/block"+str(i)+".png","r")
        blocklist.append("block"+str(i)+".png")
        i += 1
      except:
        break 
    #("brick",Brick,blocklist,50,self.level.setSelection),
    self.elementList = [
      ("apparitiondoor",ApparitionDoor,["porte.png"],188,self.level.setSelection),

      ]
    self.decorList = [
      ("caisse",Caisse,["caisse.png"],100,self.level.setSelection),
    ]
    self.levelObject = [
      ("badguy",LevelObject,["badguy.1.1.png"],100)
      ]
    self.level.setElementList(blocklist,self.elementList)

  def initialisation(self):
    x = 20
    y = 20
    for eltType in self.elementList:
      for elt in eltType[2]:
        self.iconeGroup.add(Picture((x,y),elt,id=self.id))
        self.description[self.id] = [(self.level.setInsertBlock,elt),(eltType[4],eltType[1])]
        self.id += 1
        y += 10 + eltType[3]
    # decor plaçable
    for eltType in self.decorList:
      for elt in eltType[2]:
        self.iconeGroup.add(Picture((x,y),elt,id=self.id))
        self.description[self.id] = [(self.level.setInsertElement,elt),(eltType[4],eltType[1])]
        self.id += 1
        y += 10 + eltType[3]
    # levelObject
    for eltType in self.levelObject:
      type = eltType[0]
      for elt in eltType[2]:
        self.iconeGroup.add(Picture((x,y),elt,id=self.id))
        self.description[self.id] = [(self.level.setLevelObject,(elt,type))]
        self.id += 1
        y += 10 + eltType[3]

    self.iconeGroup.add(Picture((200,20),"icone.del.png",id=self.id))
    self.description[self.id] = [(self.level.setDelete,None)]
    self.id += 1
    self.iconeGroup.add(Picture((320,20),"icone.rot.png",id=self.id))
    self.description[self.id] = [(self.level.setRotation,None)]
    self.id += 1
    self.iconeGroup.add(Picture((440,20),"icone.mov.png",id=self.id))
    self.description[self.id] = [(self.level.setDeplacement,None)]
    self.id += 1
    self.iconeGroup.add(Picture((560,20),"icone.copy.png",id=self.id))
    self.description[self.id] = [(self.level.setCopy,None)]
    self.id += 1
    self.iconeGroup.add(Picture((680,20),"icone.block.png",id=self.id))
    self.description[self.id] = [(self.level.setDisplayBlock,None)]
    self.id += 1

  def draw(self):
    self.iconeGroup.draw(self.screen)
  
  def actMB1(self,(x,y)):
    """ clic gauche de la souris (Mouse Button 1) """
    for sp in self.iconeGroup.sprites():
      if sp.rect.collidepoint((x,y)):
        liste = self.description[sp.id]
        for a in liste:
          a[0](a[1])
        return 1
    return 0
