
# -*- coding: utf-8 -*-
# Brunie Nicolas, War Of Blood

try:
  import random
  import math
  import pygame
  from Common import *
  from Angle import drawLoadedImageLine,cangle
  from Particle import *
  from pygame.locals import *
  from ClassWeapon import Weapon
  from Animation import AnimationOnScreen
  from Blast import Force
  import sys
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)
  sys.exit(2)

def pint(pos):
  x,y = pos
  return int(x),int(y)

class Bullet:
  def __init__(self,power,direction,pos,pg,target,invisibility = 0,img="bullet.png",life = 350):
    self.invisibility = invisibility
    self.particleGestionner = pg
    self.power = power
    self.direction = direction
    self.pos = pos
    self.screen = pg.screen
    self.id = None
    self.active = 1
    self.update_tmp = 50
    self.tmp_time = 0
    self.tmp_rate = 10
    self.target = target
    self.blood = 0 # limite de la creation de sang, a revoir
    self.life = life
    self.image,self.rect = load_png(img)
    self.image = pygame.transform.rotate(self.image,-cangle(direction[0],direction[1]))
    self.rect = self.image.get_rect()
    self.rect.center = pos

  def setId(self,id):
    self.id = id

  def update(self,time):
    self.life -= time
    if self.life < 0:
      return 0 
    self.tmp_time += time
    if 1:
      x,y = self.pos
      vx,vy = self.direction
      vx = float(vx) * float(time) / float(100)
      vy = float(time) * float(vy) / float(100)
      self.pos = (float(x)+vx),(float(y)+vy)
      self.rect.center = self.pos
      if not self.invisibility: # pygame.draw.circle(self.screen,(0,0,0,255),pint(self.pos),1)
        self.particleGestionner.screen.blit(self.image,self.rect)
        if 1: 
          px,py = self.pos
          px += random.randrange(-10,10)
          py += random.randrange(-10,10)
          particle = ComplexParticleSystem(self.particleGestionner.screen,(px,py),400,"cloud2.png",random.randrange(1,5) * 0.03 + 0.22,500)   # 500 argument de décroissance
          self.particleGestionner.attach(particle)

      for ob in self.target.sprites():
        if ob.rect.collidepoint(pint(self.pos)):
          #if self.blood:
          ob.looseLife(-1.3 * float(time),self.pos,self.particleGestionner,self.target) 
          if not self.blood:
            #ob.looseLife(-1.3 * float(time),self.pos,self.particleGestionner,self.target) 
            self.blood = 1
            screen = self.particleGestionner.screen
            x,y = pint(self.pos)
            dx,dy = self.direction
            f = abs(float(dx)) + abs(float(dy))
            dx = float(4) * float(dx) /  f
            dy = float(4) * float(dy) /  f
            direction = dx,dy 
            rate = 1
            ttl = 30
            range = (-1,2,-1,2)
            life = 400
            number = 10
            ps = ParticleSystem(screen,x,y,direction,rate,ttl,number,self.particleGestionner.background,range,life,back=0,type="blood")
            # back à 1 pour que le sang reste
            self.particleGestionner.attach(ps)

    return 1
