# -*- coding: utf-8 -*-
#
# Brunie Nicolas, War Of Blood
#
# Calcul d'angle

import math
from Common import load_png
import pygame

def cangle(vx,vy):
  if vx >= 0:
    if vx == 0 and vy != 0: 
      return abs(vy) / vy * 90
    elif vy == 0 and vx == 0:
      return 0
    else:
      return 180.0 * math.atan(vy/vx) / math.pi
  else:
    return 180 - 180.0 * math.atan(vy/abs(vx)) / math.pi
    

def angle(vx,vy):
  a = cangle(vx,vy)
  if a > 180:
    return a - 360
  else: return a

def drawImageLine(screen,img,imgPointe,posOrigine,posCible):
  image,rect = load_png(img)
  pox,poy = posOrigine
  pcx,pcy = posCible
  dx,dy = pcx-pox,pcy-poy
  norme = math.sqrt(dx**2+dy**2)
  vx,vy = float(dx) / norme, float(dy) / norme
  a = cangle(dx,dy)
  # print a
  imageOriente = pygame.transform.rotate(image,-a)
  rectOriente = imageOriente.get_rect()
  h,w = rectOriente.height, rectOriente.width
  liste = []
  # valeur = int(math.sqrt(dy**2+dx**2) / math.sqrt(h**2+w**2))
  valeur = int(math.sqrt(dy**2+dx**2) / 30) #math.sqrt(h**2+w**2))
  pas = 30
  for i in range(valeur):
    rect = pygame.Rect((0,0),(w,h))
    rect.center = (pox+i*vx*pas),(poy+i*vy*pas)
    liste.append(rect)
  for rect in liste:
    screen.blit(imageOriente,rect)
  imagePointe,rectPointe = load_png(imgPointe)
  imagePointe = pygame.transform.rotate(imagePointe,-a)
  rectPointe = imagePointe.get_rect()
  rectPointe.center = posCible#pox+valeur*vx*pas,poy+valeur*vy*pas 
  screen.blit(imagePointe,rectPointe)
    

def drawLoadedImageLine(screen,image,imagePointe,posOrigine,posCible):
  pox,poy = posOrigine
  pcx,pcy = posCible
  dx,dy = pcx-pox,pcy-poy
  norme = math.sqrt(dx**2+dy**2)
  vx,vy = float(dx) / norme, float(dy) / norme
  a = cangle(dx,dy)
  # print a
  imageOriente = pygame.transform.rotate(image,-a)
  rectOriente = imageOriente.get_rect()
  h,w = rectOriente.height, rectOriente.width
  liste = []
  # valeur = int(math.sqrt(dy**2+dx**2) / math.sqrt(h**2+w**2))
  valeur = int(math.sqrt(dy**2+dx**2) / 30) #math.sqrt(h**2+w**2))
  pas = 30
  for i in range(valeur):
    rect = pygame.Rect((0,0),(w,h))
    rect.center = (pox+i*vx*pas),(poy+i*vy*pas)
    liste.append(rect)
  for rect in liste:
    screen.blit(imageOriente,rect)
  imagePointe = pygame.transform.rotate(imagePointe,-a)
  rectPointe = imagePointe.get_rect()
  rectPointe.center = posCible#pox+valeur*vx*pas,poy+valeur*vy*pas 
  screen.blit(imagePointe,rectPointe)


def rectIntersetLine(rect,line):
  """ on veut savoir si line définit par deux point intersecte le rectangle rect
    on donne un pas de calcul """
  pass

def drawVector(screen,dx,dy,(px,py)):
  """ affichage d'un vecteur par une ligne terminée d'un disque pour indiquer la direction """
  pygame.draw.line(screen,(255,0,0),(px,py),(px+dx*10,py+dy*10),5)
  pygame.draw.circle(screen,(255,0,0),(px+dx*100,py+dy*100),25)

