# -*- coding: utf-8 -*-
# Brunie nicolas, War Of Blood

try:
  import random
  import math
  import pygame
  import sys
  from pygame.locals import *
  from Common import *
  from Animation import *
  from Blast import Movable, Force
  from Angle import drawVector
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)

class CommonCharacter(pygame.sprite.Sprite,Movable):
  def __init__(self,pe):
    pygame.sprite.Sprite.__init__(self)
    Movable.__init__(self,pe,15,type=1)
    self.animation = AnimationGestionner()
    screen = pygame.display.get_surface()
    self.screen = screen
    self.life = 1000
    self.networkId = None
    self.listResume = []
    self.globalpos = 0,0
    self.attachementGroup = pygame.sprite.Group()
    self.attachement = []


  def getHeadResume(self):
    return "chg %d %d" % self.networkId

  def getListResume(self):
    return self.listResume

  def looseLife(self,n,(x,y),pg,targets):
    self.life += n

  def looseLife2(self,n):
    self.life += n

  def getLife(self):
    return (self.life / 200) + 1

  def die(self):
    pass

  def deplaceAttachement(self,dx,dy):
    """ spécifique au sous-classes """
    pass

  def updateGlobalPosition(self,dx,dy):
    gpx,gpy = self.globalpos
    self.globalpos = gpx+dx,gpy+dy

  def forcedMouvement(self,dx,dy):
    dx,dy = int(dx),int(dy)
    self.rect.move_ip(dx,dy)
    self.deplaceAttachement(dx,dy)
    
  def deplacement(self,dx,dy,initial=None):
    if initial != None:
      self.updateGlobalPosition(dx,dy)
    self.rect.move_ip(dx,dy)
    self.deplaceAttachement(dx,dy)

