# -*- coding: utf-8 -*-
# brunie nicolas, War Of Blood

try:
  import pygame
  from pygame.locals import *
  from Common import *
  from Perso import *
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)


class Interface:
  def __init__(self,screen,background,perso):
    self.screen = screen
    self.background = background
    self.perso = perso
    rect = self.screen.get_rect()
    self.longueur = rect.width
    self.hauteur = rect.height
    self.iconeList = []
    self.updateTime = 1000
    self.tmp = 0

  def loadIconeList(self):
    self.iconeList = self.perso.getAllDescription()

  def render(self,time):
    self.tmp += time
    if self.tmp > self.updateTime:
      self.tmp = 0
      self.iconeList = self.perso.getAllDescription()
    nom,img = self.perso.getWeapon()
    i = 0
    h_tmp = 20 # hauteur d'affichage temporaire
    for icone in self.iconeList:
      n,image = icone
      if image == None: continue
      if n != nom: 
        rect = image.get_rect()
        l,h = rect.width,rect.height
        surface = pygame.transform.scale(image,(l/2,h/2))
        h = h / 2
      else:
        rect = image.get_rect()
        l,h = rect.width,rect.height
        surface = image
      self.screen.blit(surface,(20,h_tmp))
      h_tmp += h
      i += 1
    self.screen.blit(self.perso.getLoadLevel(),(self.longueur-210,20))
    #self.screen.blit( self.perso.getSurfaceLife2(),(self.longueur / 2 - 3 * 45 ,10))
    self.perso.getSurfaceLife2(self.screen,self.longueur / 2 - 3 * 45, 10)
    self.perso.renderAttachement(self.screen)


  def saveScreen(self):
    i = 0
    while 1:
      try:
        open("screen"+str(i)+".JPG","r")
      except:
        break
      i += 1
    pygame.image.save(self.screen,"screen"+str(i)+".JPG")

