# -*- coding: utf-8 -*-
# Serveur de base pour War Of Blood

import sys

HOST = sys.argv[1]
PORT = int(sys.argv[2]) # raw_input("port ?"))

import socket,sys,threading

def getId(ch):
  l = ch.split(" ")
  return int(l[1]),int(l[2])

class ThreadClient(threading.Thread):

  def __init__(self,conn,id):
    threading.Thread.__init__(self)
    self.connexion = conn
    self.id = id
    self.subid = 0
    self.knowId = []

  def run(self):
    # Dialogue avec le client
    nom = self.getName()
    while 1:
      msgClient = self.connexion.recv(1024)
      #print ("#%s#" % msgClient)
      if msgClient == "<getid>":
        couple = self.id,self.subid
        self.subid += 1
        self.connexion.send(("<id %d %d>" % couple))
      elif msgClient == "<stop>":
        self.connexion.send("<stop>")
        break
      elif msgClient == "<point>":
        score[self.id] += 1
      elif msgClient == "<getpoint>":
        msg = ""
        for k in score.keys():
          if k != self.id: msg += ("<print %d : %d points>" % (k,score[k]))
          else: msg += ("<print %d : %d points (yours)>" % (k,score[k]))
      else:
        message = msgClient
        for key in conn_client.keys():
          client = conn_client[key] 
          idg,con = client
          if idg != self.id:
            try:
              con.send(message)
            except:
              print "erreur d'envoi"
              conn_client.pop(key)
    self.connexion.close()
    del conn_client[nom]
    print "Client %s deconnecté." % nom
    # le thread se termine ici

mySocket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
try:
  mySocket.bind((HOST,PORT))
except socket.error:
  print "la liaison du socket à l'adresse choisie a echoué"
  sys.exit()
print "serveur prêt, en attente de requêtes ... "
mySocket.listen(5)

conn_client = {}
knowId = {}
score = {}
id = 0
while 1:
  connexion, adresse = mySocket.accept()
  th = ThreadClient(connexion,id)
  knowId[id] = []
  score[id] = 0
  th.start()
  it = th.getName()
  conn_client[it] = (id,connexion)
  id += 1
  print "Client %s connecté, adresse IP %s, port %s"% (it,adresse[0],adresse[1])
  #connexion.send("Vous etes connecté. Envoyez vos messages")
